<?php

//===================================================
// CLASS NormalizeArray
// Description: 
// Accept a number off arrays with the keys from
// the same domain, builds the closure of the
// key domain with each call to method Add().
// An array can then be normalized by a call to Arr().
// This will fill the array for non-existant keys
// with the value "-".
//===================================================
class NormalizeArray {
	var $fillValue="-";
	var $allkeys;
//----------------
// CONSTRUCTOR
	function NormalizeArray() {
}

//----------------
// PUBLIC METHODS
	function Add($arr) {
		$keys = array_keys($arr);
		for( $i=0; $i<count($keys); ++$i ) {
			$this->allkeys[$keys[$i]]=true;
		}
	}
	
	function Arr($arr) {
		$keys = array_keys($this->allkeys);
		for( $i=0; $i<count($keys); ++$i ) {
			if( $arr[$keys[$i]]==false ) 
				$arr[$keys[$i]] = $this->fillValue;
		}
		return $arr;
	}
} // Class

function PrintArr($a) {
	echo "Array:<br>";
	$keys = array_keys($a);
	sort($keys);
	for($i=0; $i<count($keys); ++$i) {
		echo "&nbsp;&nbsp; a[$keys[$i]]=".$a[$keys[$i]]."<br>";
	}
}

//========================================
// Test harness for class NormalizeArray

$datay1=array (
	1 => 1.5,
	2 => 3,
	3 => 1,	
	5 => 5,	
	7 => 2
);	
			
$datay2=array (
	1 => 1,
	3 => 5,
	4 => 7,	
	5 => 3,	
	6 => 2
);		

$datay3=array (
	12 => 9
);


$norm = new NormalizeArray();
$norm->Add($datay1);
$norm->Add($datay2);
$norm->Add($datay3);

PrintArr($norm->Arr($datay1));
PrintArr($norm->Arr($datay2));
PrintArr($norm->Arr($datay3));

	

?>

